package org.xbib.interlibrary.action.resolve;

import org.xbib.interlibrary.api.BibliographicDescription;
import org.xbib.interlibrary.api.action.Response;
import org.xbib.interlibrary.api.action.ResponseBuilder;

public class ResolveServiceResponseBuilder implements ResponseBuilder<ResolveRequest, ResolveServiceResponse> {

    private ResolveRequest request;

    private Response.Status status;

    private Throwable throwable;

    protected String service;

    protected BibliographicDescription bibliographicDescription;

    protected Object object;

    ResolveServiceResponseBuilder() {
        this.status = Response.Status.UNDEFINED;
    }

    @Override
    public ResolveServiceResponseBuilder setRequest(ResolveRequest request) {
        this.request = request;
        return this;
    }

    @Override
    public ResolveServiceResponseBuilder setStatus(String key, Response.Status status) {
        this.status = status;
        return this;
    }

    @Override
    public Response.Status getStatus() {
        return status;
    }

    @Override
    public ResponseBuilder<ResolveRequest, ResolveServiceResponse> setThrowable(Throwable throwable) {
        this.throwable = throwable;
        return this;
    }

    @Override
    public Throwable getThrowable() {
        return throwable;
    }

    @Override
    public ResponseBuilder<ResolveRequest, ResolveServiceResponse> setThrowable(String key, String message, Throwable throwable) {
        this.throwable = throwable;
        return this;
    }

    public ResolveServiceResponseBuilder setService(String service) {
        this.service = service;
        return this;
    }

    public ResolveServiceResponseBuilder setBibliographicDescription(BibliographicDescription bibliographicDescription) {
        this.bibliographicDescription = bibliographicDescription;
        return this;
    }

    public ResolveServiceResponseBuilder setSource(Object object) {
        this.object = object;
        return this;
    }

    @Override
    public ResolveServiceResponse build() {
        return new ResolveServiceResponse(request, this);
    }
}
